## saods9 7.0.1+dfsg

=== Makefile ===
include make.include
include make.pkgs

.NOTPARALLEL :

#--------------------------defines

export root := $(shell pwd)

USER	= joye
#DEST	= bokhara.cfa.harvard.edu
DEST	= bokhara

DIRS	= bin lib include man html share dist

#--------------------------dirs

SRCDIR	= src
DOCDIR	= doc
DS9DIR	= ds9

#--------------------------cache

CACHE = $(root)/myconfig.cache
LOCALCACHE = myconfig.cache

#--------------------------dist

DS9APP=SAOImage\ DS9\ $(DS9VERSION)
XPAAPP=XPA\ $(XPAVERSION)

#--------------------------blt stuff
BLTINCL	= blt.h bltVector.h

BLTWITHOUT = \
	--without-jpegincdir --without-jpeglibdir \
	--without-pngincdir --without-pnglibdir \
	--without-tiffincdir --without-tifflibdir \
	--without-xpmincdir --without-xpmlibdir \
	--without-xrandrincdir --without-xrandrlibdir \
	--without-expatincdir --without-expatlibdir \
	--without-mysqlincdir --without-mysqllibdir

#--------------------------flags
ifeq ($(OS),unix)
  TCLDIRDIR= $(TCLDIR)/unix
  TKDIRDIR= $(TKDIR)/unix

  XFLAGS = --x-includes=$(X11INCLUDE) --x-libraries=$(X11LIB)

  TCLFLAGS = $(XFLAGS) $(EXTTCLFLAGS)
  TKTABLEFLAGS = $(XFLAGS)
  BLTFLAGS = $(XFLAGS) $(BLTWITHOUT)
  TKIMGFLAGS = $(XFLAGS)
  XPAFLAGS = $(XFLAGS)

  SIGNAL= signal
  SIGNALCLEAN= signalclean

  OPTDIR= unix
  OPTDIRCLEAN= unixclean
endif

ifeq ($(OS),windows)
  TCLDIRDIR= $(TCLDIR)/win
  TKDIRDIR= $(TKDIR)/win

  TCLFLAGS = --enable-symbols
  TKTABLEFLAGS = --enable-symbols
  BLTFLAGS = --without-x $(BLTWITHOUT) \
	--without-xftincdir --without-xftlibdir
  TKIMGFLAGS = --enable-symbols
  XPAFLAGS = --without-x
  PREHTMLFLAGS = config_BUILD_TCLSH=tclsh85sg \
	config_TARGET_TCL_SCRIPT_DIR=$(root)/lib/tcl8.5

  SIGNAL=
  SIGNALCLEAN=

  OPTDIR= win
  OPTDIRCLEAN= winclean
endif

ifeq ($(OS),macosx)
  TCLDIRDIR= $(TCLDIR)/unix
  TKDIRDIR= $(TKDIR)/unix

  TCLFLAGS = --enable-aqua
  BLTFLAGS = --x-includes=/usr/X11/include --x-libraries=/usr/X11/lib \
	$(BLTWITHOUT)

# xpa configure will not accept --without-x
  XPAFLAGS = --with-x=disabled --enable-posix_spawn
  PREHTMLFLAGS = config_TARGET_LIBS="-framework CoreFoundation -framework Carbon" \
	config_TARGET_X_INC="-I$(root)/$(TKDIR)/xlib" \
	config_TARGET_X_LIBS=" "

  FUNTOOLSFLAGS = --enable-posix_spawn

  SIGNAL= signal
  SIGNALCLEAN= signalclean

  OPTDIR= macosx
  OPTDIRCLEAN= macosxclean
endif

CVSFILES = acknowledgement \
	admin \
	checkdns \
	tkmpeg \
	COPYING \
	copyright \
	iis \
	make.darwin64x86lion \
	make.darwinx86lion \
	make.darwinlion \
	make.darwin64x86snowleopard \
	make.darwinx86snowleopard \
	make.darwinsnowleopard \
	make.darwin64x86leopard \
	make.darwinx86leopard \
	make.darwinppcleopard \
	make.darwinleopard \
	make.darwinx86tiger \
	make.darwinppctiger \
	make.darwintiger \
	make.linux \
	make.linux64 \
	make.macosxsnowleopard \
	make.macosxx86leopard \
	make.macosxppcleopard \
	make.macosxleopard \
	make.macosxx86tiger \
	make.macosxppctiger \
	make.macosxtiger \
	make.solaris \
	make.source \
	make.windows \
	make.pkgs \
	Makefile \
	notes.txt \
	mods \
	README \
	saotk \
	unix \
	win \
	macosx \
	tests \
	doc \
	cmaps \
	template \
	src \
	msgs \
	ds9 \
	util \
	compilers \
	$(ZVFSDIR)/Makefile \
	$(WCSSUBSDIR)/Makefile \
	$(SLADIR)/Makefile \
	$(RICEDIR)/Makefile \
	$(HCOMPRESSDIR)/Makefile \
	$(PLIODIR)/Makefile

#	$(BLTDIR)/src/Makefile-macosx.in \
#	$(BLTDIR)/src/bltMacOSX.h \
#	$(BLTDIR)/src/bltMacOSX.c \
#	$(BLTDIR)/src/macosx.c

ZIPOBJS	 = zipfile.o \
	zipup.o \
	fileio.o \
	util.o \
	globals.o \
	crypt.o \
	ttyio.o \
	unix.o \
	crc32.o \
	deflate.o \
	trees.o

#--------------------------build
all	: build

build : dirs \
	tcl tk \
	tktable tkcon xmlrpc blt \
	zlib tclxml tkimg tkmpeg html \
	xpa iis checkdns $(SIGNAL) funtools \
	sla ast wcssubs \
	rice hcompress plio \
	$(OPTDIR) \
	saotk zip zvfs ds9

doc	: FORCE
	@echo "Making Documentation..."
	cd $(DOCDIR); $(MAKE)

#--------------------------language

language: FORCE
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl da iso8859-1
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl de iso8859-1
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl es iso8859-1
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl fr iso8859-1
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl pt iso8859-1
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl cs iso8859-2
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl ja euc-jp
	grep 'msgcat::mc' src/*.tcl | tclsh8.5 util/mergedict.tcl zh big5

#--------------------------items

ds9	: scrub
	@echo "Making DS9..."
	cd $(DS9DIR); $(MAKE)

ifeq ($(OS),macosx)
ds9app	: ds9
	cd $(DS9DIR); $(MAKE) ds9app

ds9dmg	: FORCE
	rm -rf dist/$(DS9APP)
	rm -rf dist/$(DS9APP).dmg
	mkdir dist/$(DS9APP)
	ln -s /Applications dist/$(DS9APP)/.
	cp -r ds9/macosx/README dist/$(DS9APP)/.
	cp -rp bin/SAOImage\ DS9.app dist/$(DS9APP)/.
	hdiutil create -srcfolder dist/$(DS9APP) dist/$(DS9APP) 

endif

ifeq ($(OS),windows)
ds9app	: ds9
	cd $(DS9DIR); $(MAKE) ds9app

ds9winzip : FORCE
	$(RM) -f dist/$(DS9APP)\ Install.*
	/cygdrive/c/Program\ Files\ \(x86\)/WinZip/wzzip -p -r dist/$(DS9APP)\ Install.zip bin/ds9app
#	/cygdrive/c/Program\ Files\ \(x86\)/WinZip\ Self-Extractor/WINZIPSE.EXE  dist/$(DS9APP)\ Install.zip -setup -i ds9/win/ds9.ico -le -runasuser -t ds9/win/message.txt -a ds9/win/about.txt -c cscript install.vbs 
	/cygdrive/c/Program\ Files\ \(x86\)/WinZip\ Self-Extractor/WINZIPSE.EXE  dist/$(DS9APP)\ Install.zip -d C:\\ds9 -i ds9/win/ds9.ico -le -overwrite -runasuser -c cscript install.vbs

xpawinzip : FORCE
	$(RM) -f dist/$(XPAAPP)\ Install.*
	/cygdrive/c/Program\ Files\ \(x86\)/WinZip/wzzip dist/$(XPAAPP)\ Install.zip bin/xpa* bin/cygwin1.dll
	/cygdrive/c/Program\ Files\ \(x86\)/WinZip\ Self-Extractor/WINZIPSE.EXE  dist/$(XPAAPP)\ Install.zip -d C:\\ds9 -le -overwrite -runasuser
endif

debug	: FORCE
	@echo "Making DS9..."
	cd $(DS9DIR); $(MAKE) debug

dirs	: FORCE
	@echo "Installing Directories..."
	@for d in $(DIRS); do if [ ! -d $$d ]; then mkdir $$d; fi done

tcl	: FORCE
	@echo "Installing Tcl..."
	cd $(TCLDIRDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) $(TCLFLAGS) --disable-shared --cache-file=$(CACHE)
	cd $(TCLDIRDIR); $(MAKE) -j $(JOBS); $(MAKE) install

tk	: FORCE
	@echo "Installing Tk..."
	cd $(TKDIRDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) $(TCLFLAGS) --disable-shared --cache-file=$(CACHE)
	cd $(TKDIRDIR); $(MAKE) -j $(JOBS); $(MAKE) install
	$(RM) -r lib/$(TKVER)/demos

tktable	: FORCE
	@echo "Installing TkTable..."
	cd $(TKTABLEDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) $(TKTABLEFLAGS) --disable-shared --cache-file=$(CACHE)
	cd $(TKTABLEDIR); $(MAKE) -j $(JOBS) ; $(MAKE) install

tkcon	: FORCE
	@echo "Installing TkCon..."
	$(RM) -r lib/$(TKCONVER)
	mkdir lib/$(TKCONVER)
	cp $(TKCONDIR)/*.tcl lib/$(TKCONVER)

xmlrpc	: FORCE
	@echo "Installing XMLRPC..."
	$(RM) -r lib/$(XMLRPCVER)
	mkdir lib/$(XMLRPCVER)
	cp $(XMLRPCDIR)/xmlrpc.tcl lib/$(XMLRPCVER)

blt	: FORCE
	@echo "Installing BLT..."
	cd $(BLTDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --with-tcl=$(root)/$(TCLDIR) --with-tk=$(root)/$(TKDIR) $(BLTFLAGS) --disable-shared --cache-file=$(CACHE)
	cd $(BLTDIR)/src; $(MAKE) -j $(JOBS) build_static
	cp $(BLTDIR)/src/*.a lib/.
	cd $(BLTDIR)/src; cp $(BLTINCL) ../../include/.

zlib  : FORCE
	@echo "Installing zlib..."
	cd $(ZLIBDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --static
	cd $(ZLIBDIR); $(MAKE) -j $(JOBS) install

tclxml	: FORCE
	@echo "Installing TCLXML..."
	cd $(TCLXMLDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --disable-shared --disable-threads --with-xml-static=1 $(TCLXMLFLAGS) --cache-file=$(CACHE)
	cd $(TCLXMLDIR); $(MAKE) -j $(JOBS) ; $(MAKE) install

tkimg	: libtiff
	@echo "Installing TKIMG..."
	cd $(TKIMGDIR); CC='$(CC)' CFLAGS='$(OPTS) -DPNG_NO_WRITE_gAMA' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --with-tcl=$(root)/$(TCLDIRDIR) --with-tk=$(root)/$(TKDIRDIR) $(TKIMGFLAGS) --disable-shared --disable-threads --cache-file=$(LOCALCACHE)
	cd $(TKIMGDIR); $(MAKE) -j $(JOBS) all; $(MAKE) install

libtiff	: FORCE
	@echo "Installing LIBTIFF..."
	cd $(TKIMGDIR)/compat/libtiff; CC='$(CC)' CFLAGS='$(OPTS)' CXX='$(CC)' CXXFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --disable-shared --cache-file=$(LOCALCACHE)
	cd $(TKIMGDIR)/compat/libtiff; $(MAKE) -j $(JOBS) ; $(MAKE) install

tkmpeg	: FORCE
	@echo "Installing TKMPEG..."
	cd $(TKMPEGDIR); $(MAKE) -j $(JOBS)
	cd $(TKMPEGDIR); $(MAKE) install

html	: FORCE
	@echo "Installing HTMLWIDGET..."
	cd $(HTMLDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' $(PREHTMLFLAGS) $(root)/htmlwidget/configure --prefix $(root) --with-tcl=$(root)/$(TCLDIR) --with-tk=$(root)/$(TKDIR) $(XFLAGS) --enable-shared=no --cache-file=$(CACHE)
	cd $(HTMLDIR); $(MAKE) headers libtkhtml.a
	cp $(HTMLDIR)/libtkhtml.a lib/.

xpa	: FORCE
	@echo "Installing XPA..."
	cd $(XPADIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --with-tcl=$(root)/$(TCLDIRDIR) $(XPAFLAGS) --disable-shared --cache-file=$(CACHE)
	cd $(XPADIR); $(MAKE) -j $(JOBS); $(MAKE) install
	cd bin; strip xpa*

iis	: FORCE
	@echo "Installing IIS..."
	cd $(IISDIR); $(MAKE) -j $(JOBS) install

checkdns: FORCE
	@echo "Installing CheckDNS..."
	cd $(CHECKDNSDIR); $(MAKE) -j $(JOBS) install

signal: FORCE
	@echo "Installing Signal..."
	cd $(SIGNALDIR); $(MAKE) -j $(JOBS) install

funtools: FORCE
	@echo "Installing Funtools..."
	cd $(FUNTOOLSDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --with-zlib=../../lib/libz.a --with-wcslib=../lib/libwcs.a --enable-mainlib $(FUNTOOLSFLAGS)
	cd $(FUNTOOLSDIR); $(MAKE) -j $(JOBS) lib
	cp $(FUNTOOLSDIR)/libfuntools.a lib/.

sla	: FORCE 
	@echo "Installint SLA..."
	cd $(SLADIR); $(MAKE) -j $(JOBS) install

ast	: FORCE
	@echo "Installing AST..."
	cd $(ASTDIR); \
	touch aclocal.m4; sleep 1; \
	touch Makefile.in; sleep 1; \
	touch configure; \
	./configure --enable-shared=no --prefix=$(root) $(ASTFLAGS) CC='$(CC)' CFLAGS='$(OPTS) -I.'; \
	$(MAKE) -j $(JOBS) ast.h install-libLTLIBRARIES install-nodist_includeHEADERS install-includeHEADERS

wcssubs	: FORCE
	@echo "Installing WCSSUBS..."
	cd $(WCSSUBSDIR); $(MAKE) -j $(JOBS) install

rice	: FORCE
	@echo "Installing RICE..."
	cd $(RICEDIR); $(MAKE) -j $(JOBS) install

hcompress: FORCE
	@echo "Installing HCOMPRESS..."
	cd $(HCOMPRESSDIR); $(MAKE) -j $(JOBS) install

plio: FORCE
	@echo "Installing PLIO..."
	cd $(PLIODIR); $(MAKE) -j $(JOBS) install

ifdef OPTDIR
$(OPTDIR) : FORCE
	@echo "Installing $(OPTDIR)..."
	cd $(OPTDIR); $(MAKE) -j $(JOBS) install
endif

saotk	: FORCE
	@echo "Installing SAOTK..."
	cd $(SAOTKDIR); $(MAKE) -j $(JOBS) install

zip	: FORCE
	@echo "Installing ZIP..."
	cd $(ZIPDIR); PREFIX=$(root) $(MAKE) -j $(JOBS) CC='$(CC)' CFLAGS='$(OPTS) -I. -DUNIX' LFLAGS1='$(OPTS)' -f unix/Makefile generic
	cd $(ZIPDIR); PREFIX=$(root) $(MAKE) -j $(JOBS) CC='$(CC)' CFLAGS='$(OPTS) -I. -DUNIX' LFLAGS1='$(OPTS)' -f unix/Makefile install
	cd $(ZIPDIR); $(RM) libzip.a
	cd $(ZIPDIR); $(AR) -cr libzip.a $(ZIPOBJS)
	cp $(ZIPDIR)/libzip.a lib/.

zvfs	: FORCE
	@echo "Installing ZVFS..."
	cd $(ZVFSDIR); $(MAKE)
	cd $(ZVFSDIR); $(MAKE) install

#--------------------------clean

scrub : FORCE
	find . -name "*[~#]" -exec rm {} \;
ifeq ($(OS),windows)
	find . -name "*stackdump*" -exec rm {} \;
endif

distclean : filesclean \
	tclclean tkclean \
	tktableclean bltclean \
	zlibclean tclxmlclean tkimgclean tkmpegclean htmlclean \
	xpaclean iisclean checkdnsclean $(SIGNALCLEAN) funtoolsclean \
	slaclean astclean wcssubsclean \
	riceclean hcompressclean plioclean \
	$(OPTDIRCLEAN) \
	saotkclean zipclean zvfsclean ds9clean srcclean \
	dirsclean 

filesclean: FORCE
	find . -name "myconfig.cache" -exec rm {} \;
	$(RM) core *~ *#

dirsclean: FORCE

=== doc/Makefile ===
include ../make.include

doc	: ref user

ref	: FORCE
	@echo "Making Reference Manual psp..."
	cd ref; html2ps -C hb -n -u -U -W b -x 1 index.html > ref.ps
	@echo "Making Reference Manual pdf"
	cd ref; ps2pdf ref.ps ref.pdf 

user	: FORCE
	@echo "Making User Manual psp..."
	cd user; html2ps -C hb -n -u -U -W b -x 1 index.html > user.ps
	@echo "Making User Manual pdf"
	cd user; ps2pdf user.ps user.pdf 

clean	: FORCE
	$(RM) core *~ *# 

distclean : FORCE
	$(RM) core *~ *# *.ps *.pdf

FORCE	:

=== ds9/Makefile ===
include ../make.include
include ../make.pkgs

#--------------------------defines

ZDIR	= zipdir/zvfsmntpt
FFILES	= $(ZDIR)/$(TCLVER) \
	$(ZDIR)/tcl8 \
	$(ZDIR)/$(TKVER) \
	$(ZDIR)/$(BLTVER) \
	$(ZDIR)/$(TCLLIBVER) \
	$(ZDIR)/$(TKCONVER) \
	$(ZDIR)/$(XMLRPCVER) \
	$(ZDIR)/src \
	$(ZDIR)/msgs \
	$(ZDIR)/doc \
	$(ZDIR)/cmaps \
	$(ZDIR)/template

ifdef FILTERCOMPILER
FILES	= $(FFILES) \
	$(ZDIR)/$(FILTERCOMPILER)
else
FILES	= $(FFILES)
endif

# for unix, macosx
MAINDIR = ../$(TKDIR)/unix
MAIN	= tkAppInit

LIBS	= \
	../lib/libsaotk.a \
	../lib/libtkhtml.a \
	../lib/libtkmpeg.a \
	../lib/$(TCLXMLVER)/libTclxml3.2.a \
	../lib/$(TKTABLEVER)/libTktable2.10.a \
	../lib/$(TKIMGVER)/libtkimgpng1.4.a \
	../lib/$(TKIMGVER)/libpngtcl1.4.3.a \
	../lib/$(TKIMGVER)/libtkimgtiff1.4.a \
	../lib/$(TKIMGVER)/libtifftcl3.9.4.a \
	../lib/$(TKIMGVER)/libtkimgjpeg1.4.a \
	../lib/$(TKIMGVER)/libjpegtcl8.2.a \
	../lib/$(TKIMGVER)/libtkimggif1.4.a \
	../lib/$(TKIMGVER)/libtkimgppm1.4.a \
	../lib/$(TKIMGVER)/libtkimgwindow1.4.a \
	../lib/$(TKIMGVER)/libzlibtcl1.2.5.a \
	../lib/$(TKIMGVER)/libtkimg1.4.a \
	../lib/libtiff.a \
	../lib/libfuntools.a \
	../lib/librice.a \
	../lib/libhcomp.a \
	../lib/libplio.a \
	../lib/libast.a \
	../lib/libast_err.a \
	../lib/libast_pal.a \
	../lib/libsaotk.a \
	../lib/libwcs.a \
	../lib/libsla.a \
	../lib/libzvfs.a \
	../lib/libzip.a \
	../lib/libz.a \
	../lib/libxpa.a \
	../lib/libiis.a \
	../lib/libcheckdns.a \
	../lib/libsignal_ext.a \
	../lib/libxxlib.a \
	../lib/libBLTX30.a \
	../lib/libBLTCore30.a \
	../lib/libtk8.5.a \
	../lib/libtcl8.5.a

# if windows, redefine
ifeq ($(OS),windows)
  MAINDIR = ../$(TKDIR)/win
  MAIN	= winMain
  RES	= ds9.res.o

  LIBS	= \
	../lib/libsaotk.a \
	../lib/libtkhtml.a \
	../lib/libtkmpeg.a \
	../lib/$(TCLXMLVER)/Tclxml32.a \
	../lib/$(TKTABLEVER)/Tktable210.a \
	../lib/$(TKIMGVER)/tkimgpng14.a \
	../lib/$(TKIMGVER)/pngtcl143.a \
	../lib/$(TKIMGVER)/tkimgtiff14.a \
	../lib/$(TKIMGVER)/tifftcl394.a \
	../lib/$(TKIMGVER)/tkimgjpeg14.a \
	../lib/$(TKIMGVER)/jpegtcl82.a \
	../lib/$(TKIMGVER)/tkimggif14.a \
	../lib/$(TKIMGVER)/tkimgppm14.a \
	../lib/$(TKIMGVER)/tkimgwindow14.a \
	../lib/$(TKIMGVER)/zlibtcl125.a \
	../lib/$(TKIMGVER)/tkimg14.a \
	../lib/libtiff.a \
	../lib/libfuntools.a \
	../lib/librice.a \
	../lib/libhcomp.a \
	../lib/libplio.a \
	../lib/libast.a \
	../lib/libast_err.a \
	../lib/libast_pal.a \
	../lib/libsaotk.a \
	../lib/libwcs.a \
	../lib/libsla.a \
	../lib/libzvfs.a \
	../lib/libzip.a \
	../lib/libz.a \
	../lib/libxpa.a \
	../lib/libiis.a \
	../lib/libcheckdns.a \
	../lib/libxxlib.a \
	../lib/libBLTX30.a \
	../lib/libBLTCore30.a \
	../lib/libtk85sg.a \
	../lib/libtcl85sg.a
endif

OBJS	= ds9.o $(MAIN).o $(RES)

#--------------------------targets

ifeq ($(OS),unix)
CFLAGS= $(CCOPT) -I. -I../include \
	-I../$(TKDIR)/generic -I../$(TKDIR)/unix \
	-I$(X11INCLUDE)

ifneq (,$(findstring darwin,$(ARCH)))

CXXFLAGS = $(CXXOPT) -I. -I../include -I$(X11INCLUDE) -DZIPFILE

all: ds9

ds9	: ds9Base ds9.zip
	$(RM) $@
	cp ds9Base ds9
	strip ds9
	cp ds9 ../bin/.
	cp ds9.zip ../bin/.
	cd ../bin; $(CODESIGN) -s "SAOImage DS9" ds9

debug	: ds9Base ds9.zip
	$(RM) $@
	cp ds9Base ds9

ds9.zip	: $(FILES)
	cd zipdir; ../../bin/zip -r9 ../ds9.zip *	

else

CXXFLAGS = $(CXXOPT) -I. -I../include -I$(X11INCLUDE)

all: ds9

ds9	: null.zip ds9Base $(FILES)
	$(RM) $@
	cp ds9Base ds9.zip
	strip ds9.zip
	cat null.zip >> ds9.zip
	cd zipdir; ../../bin/zip -rA9 ../ds9.zip *
	mv ds9.zip ds9
	cp ds9 ../bin/.

debug	: null.zip ds9Base $(FILES)
	$(RM) $@
	cp ds9Base ds9.zip
	cat null.zip >> ds9.zip
	cd zipdir; ../../bin/zip -rA9 ../ds9.zip *
	mv ds9.zip ds9
endif

endif

ifeq ($(OS),windows)
CFLAGS= $(CCOPT) -I. -I../include \
	-I../$(TKDIR)/generic -I../$(TKDIR)/win \
	-I$(X11INCLUDE)

CXXFLAGS = $(CXXOPT) -I. -I../include -I$(X11INCLUDE) -DZIPFILE

all: ds9.exe

ds9.exe	: ds9Base.exe ds9.zip ../bin/tcc
	$(RM) $@
	cp ds9Base.exe ds9.exe
	strip ds9.exe
	cp ds9.exe ../bin/.
	cp ds9.zip ../bin/.
	cp /bin/cygwin1.dll ../bin/.
	cp /bin/cygxml2-2.dll ../bin/.
	cp /bin/cygstdc++-6.dll ../bin/.
	cp /bin/cygiconv-2.dll ../bin/.
	cp /bin/cygz.dll ../bin/.
	cp /bin/cyggcc_s-1.dll ../bin/.
	cp /bin/cygjbig-2.dll ../bin/.

debug	: ds9Base.exe ds9.zip ../bin/tcc
	$(RM) $@
	cp ds9Base.exe ds9.exe

ds9app	: ds9.exe
	$(RM) -r ../bin/ds9app
	mkdir ../bin/ds9app
	cp ds9.exe ../bin/ds9app/.
	cp ds9.zip ../bin/ds9app/.
	cp /bin/cygwin1.dll ../bin/ds9app/.
	cp /bin/cygxml2-2.dll ../bin/ds9app/.
	cp /bin/cygstdc++-6.dll ../bin/ds9app/.
	cp /bin/cygiconv-2.dll ../bin/ds9app/.
	cp /bin/cygz.dll ../bin/ds9app/.
	cp /bin/cyggcc_s-1.dll ../bin/ds9app/.
	cp /bin/cygjbig-2.dll ../bin/ds9app/.
	cp -rp ../bin/tcc ../bin/ds9app/.
	cp ../ds9/win/install.vbs ../bin/ds9app/.

ds9.zip	: $(FILES)
	cd zipdir; ../../bin/zip -r9 ../ds9.zip *	

endif

ifeq ($(OS),macosx)
CFLAGS= $(CCOPT) -I. -I../include \
	-I../$(TKDIR)/generic -I../$(TKDIR)/macosx \
	-I$(X11INCLUDE)

CXXFLAGS = $(CXXOPT) -I. -I../include -I$(X11INCLUDE) -DZIPFILE

all: ds9

ds9	: ds9Base ds9.zip
	$(RM) $@
	cp ds9Base ds9
	strip ds9
	cp ds9 ../bin/.
	cp ds9.zip ../bin/.

debug	: ds9Base ds9.zip
	$(RM) $@
	cp ds9Base ds9

ds9app	: ds9
	rm -rf ../bin/SAOImage\ DS9.app
	cp -rp macosx/SAOImage\ DS9.app ../bin/.
	cd ../bin/SAOImage\ DS9.app; find -d . -name CVS -exec rm -rf {} \;
	cp -p ../bin/ds9 ../bin/SAOImage\ DS9.app/Contents/MacOS/.
	cp -p ../bin/ds9.zip ../bin/SAOImage\ DS9.app/Contents/MacOS/.
	cd ../bin; $(CODESIGN) -s "SAOImage DS9" SAOImage\ DS9.app

ds9.zip	: $(FILES)
	cd zipdir; ../../bin/zip -r9 ../ds9.zip *	

endif

$(MAIN).o : $(MAIN).c
	$(CC) $(CFLAGS) -DTK_LOCAL_APPINIT=SAOAppInit \
	-DTK_LOCAL_MAIN_HOOK=SAOLocalMainHook -c $(MAIN).c -o $@

$(MAIN).c : $(MAINDIR)/$(MAIN).c
	cp $(MAINDIR)/$(MAIN).c .

null.zip:
	echo . | zip null.zip -
	zip null.zip -d -

zipdir	: 
	mkdir zipdir
	mkdir $(ZDIR)

$(ZDIR)/$(TCLVER) : zipdir ../lib/$(TCLVER)
	$(RM) -r $@
	cp -r ../lib/$(TCLVER) $(ZDIR)/.

$(ZDIR)/tcl8 : zipdir ../lib/tcl8
	$(RM) -r $@
	cp -r ../lib/tcl8 $(ZDIR)/.

$(ZDIR)/$(TKVER) : zipdir ../lib/$(TKVER)
	$(RM) -r $@
	cp -r ../lib/$(TKVER) $(ZDIR)/.
	rm -rf $(ZDIR)/$(TKVER)/images
	rm -rf $(ZDIR)/$(TKVER)/demos

$(ZDIR)/$(BLTVER) : zipdir
	$(RM) -r $@
	mkdir $(ZDIR)/$(BLTVER)
	mkdir $(ZDIR)/$(BLTVER)/afm
	cp ../$(BLTDIR)/library/graph.tcl $(ZDIR)/$(BLTVER)/.
	cp ../$(BLTDIR)/library/bltGraph.pro $(ZDIR)/$(BLTVER)/.
	cp ../$(BLTDIR)/library/tclIndex $(ZDIR)/$(BLTVER)/.
	cp ../$(BLTDIR)/library/afm/*.afm $(ZDIR)/$(BLTVER)/afm/.

$(ZDIR)/$(TCLLIBVER) : zipdir
	$(RM) -r $@
	mkdir $(ZDIR)/$(TCLLIBVER)
	cp -r ../$(TCLLIBDIR)/modules/base64 $(ZDIR)/$(TCLLIBVER)/.
	cp -r ../$(TCLLIBDIR)/modules/ftp $(ZDIR)/$(TCLLIBVER)/.
	cp -r ../$(TCLLIBDIR)/modules/log $(ZDIR)/$(TCLLIBVER)/.
	cp -r ../$(TCLLIBDIR)/modules/textutil $(ZDIR)/$(TCLLIBVER)/.
	cp -r ../$(TCLLIBDIR)/modules/math $(ZDIR)/$(TCLLIBVER)/.

$(ZDIR)/$(TKCONVER) : zipdir ../lib/$(TKCONVER)
	$(RM) -r $@
	cp -r ../lib/$(TKCONVER) $@

$(ZDIR)/$(XMLRPCVER) : zipdir ../lib/$(XMLRPCVER)
	$(RM) -r $@
	cp -r ../lib/$(XMLRPCVER) $@

$(ZDIR)/src : zipdir ../src/*.tcl
	$(RM) -r $@
	cp -r ../src $(ZDIR)/.

$(ZDIR)/msgs : zipdir ../msgs/*
	$(RM) -r $@
	cp -r ../msgs $(ZDIR)/.

$(ZDIR)/doc : zipdir ../doc/* ../doc/ref/* ../doc/user/* ../doc/release/*
	$(RM) -r $@
	cd ..; find doc -name "*.html" | cpio -pdmuv ds9/$(ZDIR)
	cd ..; find doc -name "*.gif" | cpio -pdmuv ds9/$(ZDIR)
	cd ..; find doc -name "*.png" | cpio -pdmuv ds9/$(ZDIR)

$(ZDIR)/cmaps : zipdir ../cmaps/*
	$(RM) -r $@
	cp -r ../cmaps $(ZDIR)/.

$(ZDIR)/template : zipdir ../template/*
	$(RM) -r $@
	cd ..; find template -name "*.tpl" | cpio -pdmuv ds9/$(ZDIR)

ifdef FILTERCOMPILER
$(ZDIR)/$(FILTERCOMPILER) : zipdir ../compilers/$(FILTERCOMPILER)
	$(RM) -r $@
	cp ../compilers/$(FILTERCOMPILER) $(ZDIR)/$(FILTERCOMPILER)
endif

#--------------------------solaris

ifeq ($(ARCH),solaris)
ds9Base	: $(OBJS) $(LIBS)
	$(RM) $@
	rm -f libstdc++.a
	ln -s `$(CXX) ${OPTS} -print-file-name=libstdc++.a` .
	$(CXX) -static-libgcc ${OPTS} \
	-o $@ $(OBJS) $(LIBS) \
	-Wl,-Bstatic -L. -lstdc++ \
	-Wl,-Bdynamic \
	-L$(X11LIB) -lX11 -lXext -lXft -lXrender -lfontconfig -lfreetype \
	-lxml2 \
	-lsocket -lnsl -ldl
	rm -f libstdc++.a
endif

#--------------------------linux

ifneq (,$(findstring linux,$(ARCH)))
ds9Base	: $(OBJS) $(LIBS)
	$(RM) $@
	rm -f libstdc++.a
	ln -s `$(CXX) ${OPTS} -print-file-name=libstdc++.a` .
	$(CXX) ${OPTS} -static-libgcc -Wl,--export-dynamic \
	-o $@ $(OBJS) $(LIBS) \
	-Wl,-Bstatic -L. -lstdc++ \
	-Wl,-Bdynamic \
	-L$(X11LIB) -lX11 -lXext -lXft -lXrender -lXss \
	-lxml2 \
	-ldl -lpthread 
	rm -f libstdc++.a
endif

#--------------------------darwin

ifneq (,$(findstring darwin,$(ARCH)))
ds9Base	: $(OBJS) $(LIBS)
	$(RM) $@
	$(CXX) ${OPTS} \
	-o $@ $(OBJS) $(LIBS) \
	-L$(X11LIB) -lX11 -lXext -lXft -lXrender -lXss -lfontconfig -lfreetype \
	-lxml2 \
	-lstdc++ -liconv
endif

#--------------------------macosx

ifeq ($(OS),macosx)
ds9Base	: $(OBJS) $(LIBS)
	$(RM) $@
	$(CXX) ${OPTS} \
	-o $@ $(OBJS) $(LIBS) \
	-lxml2 \
	-lstdc++ -liconv \
	-sectcreate __TEXT __tk_rsrc ../$(TKDIR)/unix/tk8.5.rsrc \
	-framework CoreFoundation -framework Carbon
endif

#--------------------------windows

ifeq ($(OS),windows)
ds9Base.exe: $(OBJS) $(LIBS)
	$(RM) $@
	$(CXX) ${OPTS} \
	-o $@ $(OBJS) $(LIBS) \
	-lxml2 -ljbig \
	-lws2_32 -limm32 -lcomctl32 -mwindows -mwin32

$(RES)	: win/ds9.rc win/ds9.ico
	windres -o $@ --define STATIC_BUILD --include ../$(TKDIR)/generic \
	--include ../$(TCLDIR)/generic --include ../$(TKDIR)/win/rc \
	--include win win/ds9.rc

../bin/tcc: ../compilers/$(TCC)
	$(RM) -r $@
	cd ../bin; unzip ../compilers/$(TCC)
	chmod +x ../bin/tcc/tcc.exe
	touch $@

endif

#--------------------------cleanup

clean	: FORCE
	$(RM) core *~ *# 

ifeq ($(OS),windows)
distclean: FORCE
	$(RM) core *~ *# ds9Base.exe ds9.exe *.zip *.o
	$(RM) -r zipdir bin/tcc
else
distclean: FORCE
	$(RM) core *~ *# ds9Base ds9 *.zip *.o
	$(RM) -r zipdir
endif

FORCE	:

=== hcompress/Makefile ===
include ../make.include

CFLAGS	= $(CCOPT) -I.

SRC	= hdecompress.c

OBJS	= $(SRC:%.c=%.o)
LIB	= libhcomp.a

$(LIB)	: $(OBJS)
	$(RM) $@
	$(AR) -cr $@ $(OBJS)

install	: $(LIB)
	cp $(LIB) ../lib/.

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f *.o *.a *.so

FORCE	:

=== rice/Makefile ===
include ../make.include

CFLAGS	= $(CCOPT) -I.

SRC	= ricecomp.c

OBJS	= $(SRC:%.c=%.o)
LIB	= librice.a

$(LIB)	: $(OBJS)
	$(RM) $@
	$(AR) -cr $@ $(OBJS)

install	: $(LIB)
	cp $(LIB) ../lib/.

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f *.o *.a *.so

FORCE	:

=== src/Makefile ===
include ../make.include

SCRIPTS = \
	2mass.tcl \
	3d.tcl \
	array.tcl \
	analysis.tcl \
	analysisparam.tcl \
	annulus.tcl \
	ar.tcl \
	backup.tcl \
	bin.tcl \
	box.tcl \
	boxannulus.tcl \
	bpanda.tcl \
	buttons.tcl \
	cat.tcl \
	catcds.tcl \
	catcdssrch.tcl \
	catcdssrchdialog.tcl \
	catcmd.tcl \
	catdialog.tcl \
	cattsv.tcl \
	catcxc.tcl \
	catflt.tcl \
	catned.tcl \
	catopt.tcl \
	catreg.tcl \
	catsdss.tcl \
	catsimbad.tcl \
	catskybot.tcl \
	catsym.tcl \
	catvot.tcl \
	centroid.tcl \
	circle.tcl \
	colorbar.tcl \
	comm.tcl \
	command.tcl \
	compass.tcl \
	composite.tcl \
	contour.tcl \
	convert.tcl \
	coord.tcl \
	cpanda.tcl \
	crop.tcl \
	crosshair.tcl \
	cube.tcl \
	debug.tcl \
	dialog.tcl \
	ellipse.tcl \
	ellipseannulus.tcl \
	epanda.tcl \
	error.tcl \
	eso.tcl \
	examine.tcl \
	export.tcl \
	external.tcl \
	fits.tcl \
	first.tcl \
	frame.tcl \
	graph.tcl \
	grid.tcl \
	group.tcl \
	header.tcl \
	help.tcl \
	http.tcl \
	hv.tcl \
	hvform.tcl \
	hvsup.tcl \
	iis.tcl \
	imexam.tcl \
	imgsvr.tcl \
	info.tcl \
	layout.tcl \
	line.tcl \
	load.tcl \
	magnifier.tcl \
	marker.tcl \
	markeranalysisplot2d.tcl \
	markeranalysisplot3d.tcl \
	markerbase.tcl \
	markerbaseannulus.tcl \
	markerbaseannulusrect.tcl \
	markerbasecenter.tcl \
	markerbaseline.tcl \
	markerbasepanda.tcl \
	markerbasepandarect.tcl \
	markerdialog.tcl \
	mask.tcl \
	manalysis.tcl \
	mbin.tcl \
	mcolor.tcl \
	medit.tcl \
	menu.tcl \
	mfile.tcl \
	mframe.tcl \
	mhelp.tcl \
	movie.tcl \
	mregion.tcl \
	mscale.tcl \
	mview.tcl \
	mwcs.tcl \
	mzoom.tcl \
	nameres.tcl \
	nsvr.tcl \
	pagesetup.tcl \
	panner.tcl \
	panzoom.tcl \
	pixel.tcl \
	photo.tcl \
	plot.tcl \
	plotsup.tcl \
	point.tcl \
	polygon.tcl \
	prefs.tcl \
	prefsdialog.tcl \
	print.tcl \
	projection.tcl \
	rgb.tcl \
	ruler.tcl \
	samp.tcl \
	sao.tcl \
	savefits.tcl \
	saveimage.tcl \
	scale.tcl \
	skyview.tcl \
	slider.tcl \
	smooth.tcl \
	source.tcl \
	starbase.tcl \
	stdfbox.tcl \
	stsci.tcl \
	template.tcl \
	text.tcl \
	tkfbox.tcl \
	util.tcl \
	vector.tcl \
	vo.tcl \
	wcs.tcl \
	xmfbox.tcl \
	xpa.tcl

INDEX	= pkgIndex.tcl

index	: $(SCRIPTS)
	echo "pkg_mkIndex . $(SCRIPTS)" | ../bin/tclsh8.4

msgs	: FORCE
	grep 'msgcat::mc' $(SCRIPTS) | cut -d[ -f2 | sed -e 's/::mc/::mcset AAA /' -e 's/]/ ""/' | sort | uniq > ../msgs/tmpl.tcl

clean	: FORCE
	$(RM) core *~ *# 

distclean : clean
	$(RM) $(INDEX)

FORCE	:

=== win/Makefile ===
include ../make.include
include ../make.pkgs

CXXFLAGS = $(CXXOPT) -I../include -I../saotk/vector \
	-I../$(TKDIR)/generic -I../$(TKDIR)/win \
	-I$(X11INCLUDE)

SRC	= rotstr.C \
	tkwin32.C \
	win32lib.C \
	xxlib.C \

OBJS	= $(SRC:%.C=%.o)

INCLS	= tkwin32.h win32lib.h xxlib.h rotstr.h

LIB	= libxxlib.a

all	: $(LIB)
install	: all
	cp $(INCLS) ../include/.
	cp $(LIB) ../lib/.

$(LIB)	: $(OBJS)
	$(RM) $@
	$(AR) -cr $@ $(OBJS)

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f *.o *.so *.a

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SRC:.C=.d)
endif

=== saotk/fitsy++/Makefile ===
include ../../make.include
include ../../make.pkgs

CXXFLAGS = $(CXXOPT) -I. -I.. -I../vector -I../util \
	-I../../include -I$(X11INCLUDE) \
	-I../../$(FUNTOOLSDIR)/filter -I../../$(FUNTOOLSDIR)/fitsy \
	-I../../$(FUNTOOLSDIR)/util

SS	= \
	alloc.C \
	allocgz.C \
	analysis.C \
	card.C \
	channel.C \
	column.C \
	compress.C \
	gzip.C \
	iis.C \
	hcompress.C \
	hdu.C \
	head.C \
	hist.C \
	hpx.C \
	file.C \
	map.C \
	mapincr.C \
	mmap.C \
	mmapincr.C \
	outchannel.C \
	outfile.C \
	outfits.C \
	outsocket.C \
	photo.C \
	plio.C \
	rice.C \
	share.C \
	sshare.C \
	smap.C \
	smmap.C \
	socket.C \
	socketgz.C \
	strm.C \
	var.C

SRC	= $(SS) \
	parser.C \
	lex.C

INCLS	= $(wildcard *.h)
OBJS	= $(SRC:%.C=%.o)

all	: $(OBJS) TAGS

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f TAGS *.o parser.output

ifdef DEPENDS
TAGS	: $(SS) $(INCLS)
	etags $+
else
TAGS	: FORCE
endif

parsers	: parser

parser	: FORCE
	bison -d -p ff -o parser.C parser.Y
	flex -Pff -olex.C lex.L

shmload	: shmload.C
	$(RM) $@
	$(CXX) $(CXXOPT) -o $@ $<
	cp $@ ../../bin/.

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SS:.C=.d)
endif

=== saotk/frame/Makefile ===
include ../../make.include
include ../../make.pkgs

CXXFLAGS = $(CXXOPT) -w \
	-I. -I.. -I../widget -I../vector -I../list -I../fitsy++ -I../util \
	-I../../include -I$(X11INCLUDE) \
	-I../../$(FUNTOOLSDIR)/util \
	-I/usr/include/libxml2 \
	-I../../$(ASTDIR)

SS	= \
	annulus.C \
	base.C \
	basecommand.C \
	basebox.C \
	baseellipse.C \
	baseline.C \
	basemarker.C \
	basepanda.C \
	box.C \
	boxannulus.C \
	bpanda.C \
	callback.C \
	circle.C \
	colorscale.C \
	colorscalergb.C \
	colorscaletrue8.C \
	colorscaletrue16.C \
	colorscaletrue24.C \
	colorscaletrue32.C \
	compass.C \
	composite.C \
	context.C \
	contour.C \
	coord.C \
	cpanda.C \
	ellipse.C \
	ellipseannulus.C \
	epanda.C \
	fitsanalysis.C \
	fitsbin.C \
	fitscompress.C \
	fitsdata.C \
	fitshealpix.C \
	fitsimage.C \
	fitsmask.C \
	fitsmap.C \
	frame.C \
	frame3d.C \
	framebase.C \
	frame3dbase.C \
	framergb.C \
	framergbtruecolor.C \
	framergbtruecolor8.C \
	framergbtruecolor16.C \
	framergbtruecolor24.C \
	frametrue.C \
	frame3dtrue.C \
	frametruecolor.C \
	frame3dtruecolor.C \
	frametruecolor8.C \
	frametruecolor16.C \
	frametruecolor24.C \
	frame3dtruecolor8.C \
	frame3dtruecolor16.C \
	frame3dtruecolor24.C \
	frblt.C \
	frcommand.C \
	fr3dcommand.C \
	frload.C \
	frmap.C \
	fr3dmap.C \
	frmarker.C \
	frmarkerxml.C \
	frsave.C \
	frscale.C \
	fvcontour.C \
	grid.C \
	grid2d.C \
	grid25d.C \
	grid3d.C \
	inversescale.C \
	line.C \
	marker.C \
	point.C \
	polygon.C \
	projection.C \
	ruler.C \
	tag.C \
	text.C \
	vect.C

ifeq ($(OS),unix)
SSP =	\
	colorscalepseudo8.C \
	framepseudo.C \
	framepseudocolor.C \
	framepseudocolor8.C
endif

SRC	= $(SS) $(SSP) \
	ciaoparser.C \
	ciaolex.C \
	ds9parser.C \
	ds9lex.C \
	parser.C \
	lex.C \
	prosparser.C \
	proslex.C \
	saoparser.C \
	saolex.C \
	tngparser.C \
	tnglex.C \
	xyparser.C \
	xylex.C

INCLS	= $(wildcard *.h)
OBJS	= $(SRC:%.C=%.o)

all	: $(OBJS) TAGS

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f TAGS *.o parser.output ds9parser.output ciaoparser.output prosparser.output tngparser.output saoparser.output xyparser.output

ifdef DEPENDS
TAGS	: $(SS) $(INCLS)
	etags $+
else
TAGS	: FORCE
endif

parsers	: ciaoparser ds9parser parser prosparser saoparser tngparser xyparser

ciaoparser : FORCE
	bison -d -p ciao -o ciaoparser.C ciaoparser.Y
	flex -Pciao -ociaolex.C ciaolex.L

ds9parser : FORCE
	bison -d -p mk -o ds9parser.C ds9parser.Y
	flex -Pmk -ods9lex.C ds9lex.L

parser : FORCE
	bison -d -p fr -o parser.C parser.Y
	flex -Pfr -olex.C lex.L

prosparser : FORCE
	bison -d -p pros -o prosparser.C prosparser.Y
	flex -Ppros -oproslex.C proslex.L

saoparser : FORCE
	bison -d -p sao -o saoparser.C saoparser.Y
	flex -Psao -osaolex.C saolex.L

tngparser : FORCE
	bison -d -p tng -o tngparser.C tngparser.Y
	flex -Ptng -otnglex.C tnglex.L

xyparser : FORCE
	bison -d -p xy -o xyparser.C xyparser.Y
	flex -Pxy -oxylex.C xylex.L

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SS:.C=.d)
endif

=== saotk/magnifier/Makefile ===
include ../../make.include

CXXFLAGS = $(CXXOPT) \
	-I. -I.. -I../widget -I../vector -I../util \
	-I../../include -I$(X11INCLUDE)

SS	= \
	magnifier.C \
	magnifiertrue.C

ifeq ($(OS),unix)
SSP =	\
	magnifierpseudo.C
endif

SRC	= $(SS) $(SSP) \
	parser.C \
	lex.C

INCLS	= $(wildcard *.h)
OBJS	= $(SRC:%.C=%.o)

all	: $(OBJS) TAGS

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f TAGS *.o $(LIB) parser.output

ifdef DEPENDS
TAGS	: $(SS) $(INCLS)
	etags $+
else
TAGS	: FORCE
endif

parsers	: parser

parser	: FORCE
	bison -d -p mg -o parser.C parser.Y
	flex -Pmg -olex.C lex.L

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SRC:.C=.d)
endif

=== saotk/util/Makefile ===
include ../../make.include
include ../../make.pkgs

CXXFLAGS = $(CXXOPT) -w \
	-I. -I.. -I../widget -I../vector -I../frame -I../fitsy++ -I../list \
	-I../../include -I$(X11INCLUDE) \
	-I../../$(FUNTOOLSDIR)/util \
	-I../../$(ASTDIR)

SRC	= attribute.C \
	grf.C \
	grf3d.C \
	gridbase.C \
	grid2dbase.C \
	grid25dbase.C \
	grid3dbase.C \
	ps.C \
	smooth.C \
	saotk.C \
	util.C

INCLS	= smooth.h \
	util.h

OBJS	= $(SRC:%.C=%.o)

all	: $(OBJS) TAGS

clean	: FORCE
	rm -f core *~ *#

distclean : clean
	rm -f TAGS *.o 

ifdef DEPENDS
TAGS	: $(SS) $(INCLS)
	etags $+
else
TAGS	: FORCE
endif

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SRC:.C=.d)
endif

=== saotk/vector/Makefile ===
include ../../make.include

CXXFLAGS = $(CXXOPT) -I. -I../util -I../../include -I$(X11INCLUDE)

SRC	= vector.C vector3d.C

INCLS	= $(wildcard *.h)
OBJS	= $(SRC:%.C=%.o)

all	: $(OBJS) TAGS

clean	: FORCE
	rm -f core *~ *# 

distclean : clean
	rm -f TAGS *.o $(LIB)

ifdef DEPENDS
TAGS	: $(SS) $(INCLS)
	etags $+
else
TAGS	: FORCE
endif

FORCE	:

ifdef DEPENDS
%.d: %.C
	set -e; $(CXX) -MM $(CXXFLAGS) $< \
	| sed 's/\($*\)\.o[ :]*/\1.o $@ : /g' > $@; \
	[ -s $@ ] || rm -f $@

include $(SRC:.C=.d)
endif

=== debian/changelog ===
saods9 (7.0.1+dfsg-1) unstable; urgency=low

  * New upstream release

 -- Ole Streicher <debian@liska.ath.cx>  Sat, 16 Jun 2012 10:30:00 +0200

saods9 (6.2+dfsg-2) unstable; urgency=low

  * Fix FTBS for hurd and kfreebsd, closes: #675899
  * Set DM-Upload-Allowed

 -- Ole Streicher <debian@liska.ath.cx>  Tue, 05 Jun 2012 11:06:04 +0200

saods9 (6.2+dfsg-1) unstable; urgency=low

  * Re-insert removed package, closes: #655648
  * New maintainer.
  * New upstream version
  * Push to policy version 3.9.3
  * Use external libraries instead of convienence copies where possible.

 -- Ole Streicher <debian@liska.ath.cx>  Sun, 13 May 2012 18:00:00 +0200

saods9 (4.0b7-2) unstable; urgency=low

  * QA upload.
  * Orphan package
  * Put package to collab-maint git
  * Fix gcc-4.3 build, closes: #461710
  * Import changes from ubuntu:
   + Transition to gfortran, closes: #449456
   + Fix tcl/tk location, closes: #450475
   + Add .desktop file and icon for it, closes: #377452
   - remove dpatch usage: die die die
  * Ack NMU's; closes: #377113, #444563, #344317

 -- Riku Voipio <riku.voipio@iki.fi>  Sun, 30 Mar 2008 15:19:23 +0300

saods9 (4.0b7-1.5) unstable; urgency=low

  * Non-maintainer upload.
  * Switched to dynamic loading of tcllib packages. It fixes FTBFS caused
    by tcllib upgrade (closes: #409488).
  * Added build-dependency on libtk-img-dev because of libtk-img splitting.
  * Switched to dynamic loading of Img package. It fixed FTBFS caused by
    libtk-img upgrade. Also, it fixes loading of incorrect Img libraries
    (closes: #429332).
  * Included patch by Martin Michlmayr which fixes FTBFS with GCC 4.3
    (closes: #417681).

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 29 Sep 2007 14:35:47 +0400

saods9 (4.0b7-1.4) unstable; urgency=low

  * NMU (credativ BSP)
  * (Build-)depend on libtktable2.9, to kill off the old version. This also
    replaces the dep on the -dev package, which was unneeded (.so is in the
    lib package).
    This will allow us to kill off libtktable, which is rc-buggy

 -- Marc 'HE' Brockschmidt <he@debian.org>  Fri, 15 Sep 2006 11:36:22 +0200

saods9 (4.0b7-1.3) unstable; urgency=high

  * Non-maintainer upload.
  * Add a manual dependency from saods9 to libtktable, as dpkg-shlibdeps
    refuses to add automatic dependency information for any soname not on
    the form "foo.so.bar" or "foo-bar.so", and "libTkTable2.9.so" is neither.
    (Closes: #374795)

 -- Steinar H. Gunderson <sesse@debian.org>  Thu,  6 Jul 2006 20:52:00 +0200

saods9 (4.0b7-1.2) unstable; urgency=low

  * NMU
  * Fix FTBFS with gcc-4.1 (Closes: #356979)
  * Use /usr/lib/tcllib1.8 instead of 1.7
  * Link against tktable2.9
  * Build-depends on libtktable-dev

 -- Julien Danjou <acid@debian.org>  Mon, 29 May 2006 15:42:39 +0200

saods9 (4.0b7-1.1) unstable; urgency=low

  * Non-maintainer upload at request of maintainer.
  * make.linux: Change /usr/X11R6/include to /usr/include/X11 in preparation
    for the coming X directory rearrangement (Closes: #344317).

 -- Kevin B. McCarty <kmccarty@debian.org>  Tue, 10 Jan 2006 10:08:27 -0500

saods9 (4.0b7-1) unstable; urgency=low

  * New upstream release;
    Along with a 3-line patch, fixes FTBFS with new GCC (Closes: #318042);
    Causes rebuild with GCC 4, as needed for transition.
  * Bump Standards-Version to 3.6.2 (no changes required).
  * ./debian/rules: get_orig_source now exists to generate a DFSG .orig
    tarball using fortran CVS copy of SLALIB, the C implementation of which is
    not GPL; the sources distributed by CfA are obfuscated (Closes: #336098).
  * Rewrite copyright file; include the unmodified license as distributed by
    CfA; document all copyright holders and licenses for packages included in
    the DFSG .orig tarball (Closes: #303665).
  * ./debian/control: Priority: extra (Closes: #315690).
  * Include generated manpage; a first step towards closing #303651.
  * Include documentation relevent to package; (Closes: #303668); selected
    items from ./ds9/doc/ and ./xpa/doc/; also include docbase templates.

 -- Justin Pryzby <justinpryzby@users.sf.net>  Thu, 17 Nov 2005 23:56:09 -0500

saods9 (3.0.3-1) unstable; urgency=low

  * Initial Release (Closes: #289371)
    - Thanks Aurelien Jarno.
  * Revert commented-out include in saotk/hal/Makefile.
    - Thanks Michael Weber.
  * Remove rpath from ds9 binary.

 -- Justin Pryzby <justinpryzby@users.sf.net>  Tue, 22 Mar 2005 11:29:52 -0500

=== debian/control ===
Source: saods9
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <debian@liska.ath.cx>
DM-Upload-Allowed: yes
Build-Depends: autotools-dev,
               debhelper (>= 7.0.50),
               html2text,
               cpio,
               libfuntools-dev,
               libstarlink-ast-dev (>= 7.0.4),
               libtk-img-dev,
               libwcstools-dev,
               libxml2-dev,
               libxrandr-dev,
               libxt-dev,
               perl,
               tcl-dev,
               tk-dev,
               zlib1g-dev
Standards-Version: 3.9.3
Homepage: http://hea-www.harvard.edu/RD/ds9/site/Home.html
Vcs-Git: git://git.debian.org/git/debian-science/packages/saods9.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/saods9.git

Package: saods9
Architecture: any
Depends: libtk-img,
         saods9-data (= ${source:Version}),
         saods9-blt,
         tcl-signal,
         tcl-xpa,
         tcllib,
         tclxml,
         tk-table (>= 2.9),
         tkcon,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: saods9-doc
Suggests: xpa-tools
Description: Image display tool for astronomy
 SAOImage DS9 is an astronomical imaging and data visualization
 application. DS9 supports FITS images and binary tables, multiple frame
 buffers, region manipulation, and many scale algorithms and colormaps. It
 provides for easy communication with external analysis tasks and is highly
 configurable and extensible via XPA and SAMP.
 .
 All versions and platforms support a consistent set of GUI and
 functional capabilities. 
 .
 DS9 supports advanced features such as 2-D, 3-D and RGB frame buffers, mosaic
 images, tiling, blinking, geometric markers, colormap manipulation, scaling,
 arbitrary zoom, cropping, rotation, pan, and a variety of coordinate
 systems.
 .
 The GUI for DS9 is user configurable. GUI elements such as the coordinate
 display, panner, magnifier, horizontal and vertical graphs, button bar, and
 color bar can be configured via menus or the command line.

Package: saods9-blt
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: BLT subpackage for saods9
 DS9 is an application for astronomical imaging and data
 visualization.
 .
 This package contains an updated and patched version of BLT for the use 
 in saods9.

Package: saods9-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Image display tool for astronomy (documentation)
 SAOImage DS9 is an astronomical imaging and data visualization
 application. DS9 supports FITS images and binary tables, multiple frame
 buffers, region manipulation, and many scale algorithms and colormaps. It
 provides for easy communication with external analysis tasks and is highly
 configurable and extensible via XPA and SAMP.
 .
 This package contains the documentation and help pages.

Package: saods9-data
Architecture: all
Depends: ${misc:Depends}
Description: Image display tool for astronomy (shared data)
 SAOImage DS9 is an astronomical imaging and data visualization
 application. DS9 supports FITS images and binary tables, multiple frame
 buffers, region manipulation, and many scale algorithms and colormaps. It
 provides for easy communication with external analysis tasks and is highly
 configurable and extensible via XPA and SAMP.
 .
 This package contains the shared data.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

BUILDPARTS:=dirs checkdns tkmpeg html iis rice hcompress plio xmlrpc unix blt saotk ds9

get-orig-source:
	sh ./debian/repack-dfsg.sh

%:
	dh $@

override_dh_auto_build:
	ln -sf make.linux make.include
	dh_auto_build -- $(BUILDPARTS)
	chmod ugo-x ds9/zipdir/zvfsmntpt/src/*.tcl
	perl -w debian/generate-man > ds9/ds9.1

override_dh_installchangelogs:
	dh_installchangelogs doc/release/r6.0.html

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
    http://hea-www.harvard.edu/RD/ds9/site/Download.html \
    http://hea-www.harvard.edu/saord/download/ds9/source/ds9\.(.*)\.tar\.gz \
    debian \
    debian/repack-dfsg.sh

## saods9 7.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -111,6 +111,9 @@
 	COPYING \
 	copyright \
 	iis \
+	make.darwin64x86mountainlion \
+	make.darwinx86mountainlion \
+	make.darwinmountainlion \
 	make.darwin64x86lion \
 	make.darwinx86lion \
 	make.darwinlion \
@@ -156,7 +159,6 @@
 	compilers \
 	$(ZVFSDIR)/Makefile \
 	$(WCSSUBSDIR)/Makefile \
-	$(SLADIR)/Makefile \
 	$(RICEDIR)/Makefile \
 	$(HCOMPRESSDIR)/Makefile \
 	$(PLIODIR)/Makefile
@@ -186,7 +188,7 @@
 	tktable tkcon xmlrpc blt \
 	zlib tclxml tkimg tkmpeg html \
 	xpa iis checkdns $(SIGNAL) funtools \
-	sla ast wcssubs \
+	ast wcssubs \
 	rice hcompress plio \
 	$(OPTDIR) \
 	saotk zip zvfs ds9
@@ -339,12 +341,8 @@
 funtools: FORCE
 	@echo "Installing Funtools..."
 	cd $(FUNTOOLSDIR); CC='$(CC)' CFLAGS='$(OPTS)' LDFLAGS='$(LIBS)' ./configure --prefix $(root) --with-zlib=../../lib/libz.a --with-wcslib=../lib/libwcs.a --enable-mainlib $(FUNTOOLSFLAGS)
-	cd $(FUNTOOLSDIR); $(MAKE) -j $(JOBS) lib
+	cd $(FUNTOOLSDIR); $(MAKE) lib
 	cp $(FUNTOOLSDIR)/libfuntools.a lib/.
-
-sla	: FORCE 
-	@echo "Installint SLA..."
-	cd $(SLADIR); $(MAKE) -j $(JOBS) install
 
 ast	: FORCE
 	@echo "Installing AST..."
@@ -407,7 +405,7 @@
 	tktableclean bltclean \
 	zlibclean tclxmlclean tkimgclean tkmpegclean htmlclean \
 	xpaclean iisclean checkdnsclean $(SIGNALCLEAN) funtoolsclean \
-	slaclean astclean wcssubsclean \
+	astclean wcssubsclean \
 	riceclean hcompressclean plioclean \
 	$(OPTDIRCLEAN) \
 	saotkclean zipclean zvfsclean ds9clean srcclean \
@@ -418,3 +416,6 @@
 	$(RM) core *~ *#
 
 dirsclean: FORCE
+	@for d in $(DIRS); do rm -rf $$d; done
+
+tclclean : FORCE

=== src/Makefile ===
--- 
+++ 
@@ -19,17 +19,19 @@
 	catcdssrch.tcl \
 	catcdssrchdialog.tcl \
 	catcmd.tcl \
+	catcxc.tcl \
 	catdialog.tcl \
-	cattsv.tcl \
-	catcxc.tcl \
 	catflt.tcl \
+	catmatch.tcl \
 	catned.tcl \
 	catopt.tcl \
+	catplot.tcl \
 	catreg.tcl \
 	catsdss.tcl \
 	catsimbad.tcl \
 	catskybot.tcl \
 	catsym.tcl \
+	cattsv.tcl \
 	catvot.tcl \
 	centroid.tcl \
 	circle.tcl \
@@ -76,8 +78,11 @@
 	load.tcl \
 	magnifier.tcl \
 	marker.tcl \
+	markeranalysispanda.tcl \
 	markeranalysisplot2d.tcl \
 	markeranalysisplot3d.tcl \
+	markeranalysisradial.tcl \
+	markeranalysisstats.tcl \
 	markerbase.tcl \
 	markerbaseannulus.tcl \
 	markerbaseannulusrect.tcl \
@@ -109,7 +114,13 @@
 	pixel.tcl \
 	photo.tcl \
 	plot.tcl \
-	plotsup.tcl \
+	plotbar.tcl \
+	plotdialog.tcl \
+	plotelement.tcl \
+	plotline.tcl \
+	plotprint.tcl \
+	plotprocess.tcl \
+	plotscatter.tcl \
 	point.tcl \
 	polygon.tcl \
 	prefs.tcl \

=== debian/changelog ===
saods9 (7.1+dfsg-1~exp2ubuntu1) raring; urgency=low

  * multiarch-tcltk.patch:
    fix FTBFS by searching for tcl/tk in multiarch directories
    depend on dpkg-dev (>= 1.16.0) for DEB_HOST_MULTIARCH

 -- Julian Taylor <jtaylor@ubuntu.com>  Sat, 20 Apr 2013 19:35:09 +0200

saods9 (7.1+dfsg-1~exp2) experimental; urgency=low

  * Fix crashes on 2D marker plots, closes: #693807
  * Remove obsolete DMUA Flag

 -- Ole Streicher <debian@liska.ath.cx>  Mon, 17 Dec 2012 13:20:43 +0100

saods9 (7.1+dfsg-1~exp1) experimental; urgency=low

  * New upstream release

 -- Ole Streicher <debian@liska.ath.cx>  Sun, 14 Oct 2012 13:47:27 +0200

saods9 (7.0.2+dfsg-1~exp1) experimental; urgency=low

  * New upstream release
  * Propagate hardening flags

 -- Ole Streicher <debian@liska.ath.cx>  Tue, 19 Jul 2012 11:30:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: saods9
 Section: science
 Priority: extra
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Ole Streicher <debian@liska.ath.cx>
-DM-Upload-Allowed: yes
 Build-Depends: autotools-dev,
+               dpkg-dev (>= 1.16.0),
                debhelper (>= 7.0.50),
                html2text,
                cpio,
@@ -38,7 +39,7 @@
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: saods9-doc
-Suggests: xpa-tools
+Suggests: xpa-tools, python-pyds9
 Description: Image display tool for astronomy
  SAOImage DS9 is an astronomical imaging and data visualization
  application. DS9 supports FITS images and binary tables, multiple frame
@@ -73,7 +74,7 @@
 Architecture: all
 Section: doc
 Depends: ${misc:Depends}
-Description: Image display tool for astronomy (documentation)
+Description: Image display tool for astronomy (help files/documentation)
  SAOImage DS9 is an astronomical imaging and data visualization
  application. DS9 supports FITS images and binary tables, multiple frame
  buffers, region manipulation, and many scale algorithms and colormaps. It
@@ -92,4 +93,4 @@
  provides for easy communication with external analysis tasks and is highly
  configurable and extensible via XPA and SAMP.
  .
- This package contains the shared data.
+ This package contains the architecture independent files.

=== debian/rules ===
--- 
+++ 
@@ -17,4 +17,4 @@
 	perl -w debian/generate-man > ds9/ds9.1
 
 override_dh_installchangelogs:
-	dh_installchangelogs doc/release/r6.0.html
+	dh_installchangelogs doc/release/r7.0.html
